#include < amxmodx >
#include < amxmisc >
#include < nvault >
#include < time >

#include "color_chat_ml.inl"

#pragma semicolon 1

new const g_sVaultName[ ] = "PlayedTime";

new g_hVault;

public plugin_init( ) {
	register_plugin( "Played Time", "1.0", "Hattrick" );
	
	register_dictionary( "played_time.txt" );
	register_dictionary( "time.txt" );
	
	register_concmd( "amx_time", "FuncCommandTime", ADMIN_BAN, "- Show the players and their time" );
	register_clcmd( "say", "FuncCommandSay" );
	
	g_hVault = nvault_open( g_sVaultName );
	
	set_task( 60.0, "FuncUpgradePlayedTime", 237567, _, _, "b" );
	
	color_chat_init( );
}

public plugin_cfg( )
	nvault_prune( g_hVault, 0, get_systime( ) - 604800 );

public plugin_end( )
	nvault_close( g_hVault );

public FuncUpgradePlayedTime( ) {
	new sName[ 32 ];
	new sData[ 32 ];
	new iMinutes;
	
	for( new iPlayer = 1; iPlayer <= 32; iPlayer++ ) {
		if( is_user_connected( iPlayer ) ) {
			get_user_name( iPlayer, sName, charsmax( sName ) );
			
			nvault_get( g_hVault, sName, sData, charsmax( sData ) );
			
			iMinutes = str_to_num( sData );
			
			iMinutes++;
			
			num_to_str( iMinutes, sData, charsmax( sData ) );
			
			nvault_set( g_hVault, sName, sData );
		}
	}
}

public FuncCommandTime( iPlayer, iLevel, iCid ) {
	if( !cmd_access( iPlayer, iLevel, iCid, 1 ) )
		return PLUGIN_HANDLED;
	
	new iUser;
	new sName[ 32 ];
	new sData[ 32 ];
	new sText[ 128 ];
	new iMinutes;
	
	console_print( iPlayer, "%L									%L", iPlayer, "CON_NAME_X", iPlayer, "CON_TIME_X" );
	
	for( iUser = 1; iUser <= 32; iUser++ ) {
		if( is_user_connected( iUser ) ) {
			get_user_name( iUser, sName, charsmax( sName ) );
			
			nvault_get( g_hVault, sName, sData, charsmax( sData ) );
			
			iMinutes = str_to_num( sData );
			
			if( iMinutes ) {
				get_time_length( iUser, iMinutes, timeunit_minutes, sText, charsmax( sText ) );
				
				console_print( iPlayer, "%32s %32s", sName, sText );
			} else {
				console_print( iPlayer, "%32s									%L", sName, iPlayer, "NOT_YET_CON" );
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

public FuncCommandSay( iPlayer ) {
	new sArgument[ 32 ];
	read_argv( 1, sArgument, charsmax( sArgument ) );
	
	if( equal( sArgument, "/orejucate" ) || equal( sArgument, "/time" ) ) {
		new sName[ 32 ];
		new sData[ 32 ];
		new sText[ 128 ];
		new iMinutes;
		
		get_user_name( iPlayer, sName, charsmax( sName ) );
		
		nvault_get( g_hVault, sName, sData, charsmax( sData ) );
		
		iMinutes = str_to_num( sData );
		
		if( iMinutes ) {
			get_time_length( iPlayer, iMinutes, timeunit_minutes, sText, charsmax( sText ) );
			
			ColorChat( iPlayer, RED, "[AMXX]^x01 %L", iPlayer, "PLAYED_TIME", sText );
		} else {
			ColorChat( iPlayer, RED, "[AMXX]^x01 %L", iPlayer, "PLAYED_TIME_NULL" );
		}
	}
}
